﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PoE_MxFilterGen.generator
{
    class card
    {
        private static string iB;

        public static void Gen(string section, int cardv)
        {
            List<string> itemBase = new List<string>();

            Root j = JsonConvert.DeserializeObject<Root>(File.ReadAllText("data/ninja.card.json", Encoding.UTF8));

            foreach (var ln in j.lines)
            {
                // Check if the item value is equal or superior to the minimum value
                if (ln.chaosValue >= cardv)
                {
                    if (!itemBase.Contains(ln.name))
                    {
                        itemBase.Add(ln.name);
                        iB = iB + string.Format(@" ""{0}""", ln.name);
                    }
                }
            }

            if (iB == null) { iB = @""""""; }
            string fn = $"gen/" + section + ".filter";
            File.AppendAllText(fn, string.Format("# Section: {0}", section) + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    Class ""Divination Card""" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    BaseType" + iB + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetTextColor 0 105 178" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBackgroundColor 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBorderColor 0 105 178" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetFontSize 45" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    CustomAlertSound ""mx_highvalue.mp3""", Encoding.UTF8);
        }
    }
}
