﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PoE_MxFilterGen.generator
{
    class fossil
    {
        private static string iB;

        public static void Gen(string section, int fossilv)
        {
            List<string> itemBase = new List<string>();

            Root j = JsonConvert.DeserializeObject<Root>(File.ReadAllText("data/ninja.fossil.json", Encoding.UTF8));

            foreach (var ln in j.lines)
            {
                // Check if the item value is equal or superior to the minimum value
                if (ln.chaosValue >= fossilv)
                {
                    if (!itemBase.Contains(ln.name))
                    {
                        itemBase.Add(ln.name);
                        iB = iB + string.Format(@" ""{0}""", ln.name);
                    }
                }
            }

            if (iB == null) { iB = @""""""; }
            string fn = $"gen/" + section + ".filter";
            File.AppendAllText(fn, string.Format("# Section: {0}", section) + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "Show" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    Class ""Stackable Currency""" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    BaseType" + iB + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetTextColor 255 165 0 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBackgroundColor 255 255 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetBorderColor 255 165 0 255" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, "    SetFontSize 40" + Environment.NewLine, Encoding.UTF8);
            File.AppendAllText(fn, @"    CustomAlertSound ""mx_fossil.mp3""", Encoding.UTF8);
        }
    }
}
